static int sock;

#ifdef	NO_SSL
static void
tino_ssl_errprint(FILE *fd)
{
  /* noting to do */
}
#else
#include "rsa.h"       /* SSLeay stuff */
#include "crypto.h"
#include "x509.h"
#include "pem.h"
#include "ssl.h"
#include "err.h"

static SSL	*ssl;
static SSL_CTX	*ssl_ctx;

static void
tino_ssl_errprint(FILE *fd)
{
  ERR_print_errors_fp(fd);
}

static void
tino_ssl_close(void)
{
  SSL_free(ssl);

  SSL_CTX_free(ssl_ctx);
}

static void
tino_ssl_client(void)
{
  SSLeay_add_all_algorithms();
  SSLeay_add_ssl_algorithms();
  SSL_load_error_strings();

  ssl_ctx = SSL_CTX_new(SSLv23_client_method());
  if (!ssl_ctx)
    ex("SSL_CTX_new");
  
  ssl = SSL_new(ssl_ctx);
  if (!ssl)
    exs("SSL_new");

  SSL_set_fd(ssl, sock);

  if (SSL_connect(ssl)!=1)
    exs("SSL_connect");
}

static void
tino_ssl_server(char *cert)
{
  SSLeay_add_all_algorithms();
  SSLeay_add_ssl_algorithms();
  SSL_load_error_strings();

  ssl_ctx = SSL_CTX_new(SSLv23_server_method());
  if (!ssl_ctx)
    ex("SSL_CTX_new");
  
  if (SSL_CTX_use_certificate_file(ssl_ctx, cert, SSL_FILETYPE_PEM)==-1)
    exs("SSL_CTX_use_cert...");

  if (SSL_CTX_use_PrivateKey_file(ssl_ctx, cert, SSL_FILETYPE_PEM)==-1)
    exs("SSL_CTX_use_Priv...");
  
  ssl = SSL_new(ssl_ctx);
  if (!ssl)
    exs("SSL_new");

  SSL_set_fd(ssl, sock);

  if (SSL_accept(ssl)==-1)
    exs("SSL_accept");
}
#endif
